$ ===========================================================================
$ [...\ENDLG\PARAM.INC]
$ e-norm-Dialog         : INCLUDE-Datei fr e-norm Parameter (Normteile)
$                         Erzeugt die PushButtons 'Ok', 'Abbrechen' und 'bernehmen'
$
$                         Fr den PushButton 'bernehmen' muss die User-Variable
$                         EN.ADMINISTRATOR auf 1 stehen, sonst wird dieser PushBuutton
$                         NICHT angezeigt.
$ ---------------------------------------------------------------------------
$ Autor                 : P. Locarek, P. Locarek SOFTWARETECHNIK
$ Copyright             : P. Locarek SOFTWARETECHNIK
$ Datum der Erstellung  :
$ letzte nderung       : 29.07.2005
$ Rev.:                 : 9.200
$ ===========================================================================


ATTRIBUTES = PARENTHESIS

Variable
   {

   if undef(U:EN.ADMINISTRATOR) or not varexist('U:EN.ADMINISTRATOR')
      {
      EN.ADMINISTRATOR = 0
      else
         {
         EN.ADMINISTRATOR = 0
         if (U:EN.ADMINISTRATOR = 1)
            {
            EN.ADMINISTRATOR = 1
            }
         }
      }
   }



MAKRO RemVar ( name )
  {
  PAR.[name] = U:[name]
  }

MAKRO REM_VAR (name; wert)
   {
   if not varexist ('U:[name]')
     {
     U:[name] = [wert]
     }
   PAR.[name] = U:[name]
   }

$----------------------------------------------------------------------------
$ Belegung fr Eingaben merken; ggf. Default Wert setzen


MAKRO RemVarDef ( name ; typ ; defaultval )
  {
  $$ mgliche typen: 'TZIBPQVW'
  $$ (T,c_text), (Z,c_numwert), (I,c_integer), (B,c_bool),
  $$ (P,c_koord), (Q,c_d3_koord), (V,c_vektor), (W,c_d3_vektor)
  $$-----------------------------------------------------------
  IF Varexist('U:[name]')=0
    {
    IF(( '[typ]' = 'T' ) or ( '[typ]' = 't' ))
        {
        =VarSet('U:[name]'; '[typ]' ; ITX( [defaultval] ))
        ELSE
            {
            =VarSet('U:[name]'; '[typ]' ; [defaultval])
            }
        }
    }
  PAR.[name] = U:[name]
  }


$----------------------------------------------------------------------------
$ Neue Belegung bei Ok speichern


MAKRO RstVar ( name )
  {
  U:[name] = PAR.[name]
  }


$----------------------------------------------------------------------------


MAKRO ParamDialog ( Titel ; hat_Hilfe ; [Inhalt] ; [OkAction] ; [SaveAction] )
  {
  DIALOG [Titel]
    {
    [[Inhalt]]
    Pushbutton OK DEFAULT 'OK'
      {
      LAYOUT
        {
        CONTROL 8
        }
      ACTION
        {
        [[OkAction]]
        }
      }

    Pushbutton ABORT
      {
      LAYOUT
        {
        SAMELINE
        CONTROL 8
        }
      }

$    Pushbutton "~0935a Permanent"
$      {
$      LAYOUT
$        {
$        SAMELINE
$        CONTROL 8
$        }
$      [[SaveAction]]
$      }

   if (EN.ADMINISTRATOR = 1)
     {
     Pushbutton "~0935a Permanent"
       {
       Layout
         {
         Sameline
         Control 8
         }
       [[SaveAction]]
       }
     }


    }
  }


$----------------------------------------------------------------------------


$MAKRO WriteFile ( Name ;DTitel ; [VARS] )
$  {
$  ACTION
$    {
$    OPEN NEW 'PARAM\[NAME].VAR'
$    WRITE DOLLAR()+"~078dc Automatisch erzeugte Parameterdatei"
$    WRITE DOLLAR()+"~09966 aus dem Parameterdialog: "+ [DTitel]
$    [[Vars]]
$    }
$  }

$----------------------------------------------------------------------------

$MAKRO WriteFilePlus ( Name ; DTitel ; DNAME ; [VARS] )
$  {
$  ACTION
$    {
$    OPEN NEW 'PARAM\[NAME].VAR'
$    WRITE DOLLAR()+"~078dc Automatisch erzeugte Parameterdatei"
$    WRITE DOLLAR()+"~09966 aus dem Parameterdialog: "+ [DTitel]+ [DNAME]
$    [[Vars]]
$    }
$  }

MAKRO WriteFilePlus(FileName; DTitel ; Section;  [VARS])
{
  ACTION
  {
    Sect__ = new.FileSection()
    SectionName__ = [Section]
    ok__ = Sect__::Open("@:PARAM\[FileName].var"; "") $ NO ITX
    if ok__
    {
      ok__ = Sect__::Select([Section])
      if ok__
      {
        =Sect__::Clear()
        =Sect__::AddLine(DOLLAR() + "~078dc Automatisch erzeugte Parameterdatei")
        =Sect__::AddLine(DOLLAR() + "~09966 aus dem Parameterdialog: " + [DTitel] + [Section])
        [[Vars]]
        ok__ = Sect__::Select("")
        if ok__
        {
          if Sect__::GetLineCountNoComment() = 0
          {
            =Sect__::Delete("")
          }
        }
        =Sect__::Write("@:PARAM\[FileName].var") $ NO ITX
        =Sect__::Close()
      }
    }
  }
}

MAKRO WriteFile(FileName; Section; [VARS])
{
  ACTION
  {
    Sect__ = new.FileSection()
    SectionName__ = [Section]
    ok__ = Sect__::Open("@:PARAM\[FileName].var"; "") $ NO ITX
    if ok__
    {
      ok__ = Sect__::Select([Section])
      if ok__
      {
        =Sect__::Clear()
        =Sect__::AddLine(DOLLAR() + "~078dc Automatisch erzeugte Parameterdatei")
        =Sect__::AddLine(DOLLAR() + "~09966 aus dem Parameterdialog: "+ [Section])
        [[Vars]]
        ok__ = Sect__::Select("")
        if ok__
        {
          if Sect__::GetLineCountNoComment() = 0
          {
            =Sect__::Delete("")
          }
        }
        =Sect__::Write("@:PARAM\[FileName].var") $ NO ITX
        =Sect__::Close()
      }
    }
  }
}

$----------------------------------------------------------------------------

MAKRO DeleteLineFromUnnamedSection(Line)
{
  ok__ = Sect__::Select("")
  if ok__
  {
    varName__ = GetVarNameFromLine([Line])
    index__ = Sect__::FindLineWithVarName(varName__)
    if index__ > -1
    {
      =Sect__::RemoveLine(index__)
    }
  }
}

$MAKRO WriteBoolean ( Name )
$  {
$  IF PAR.[Name]
$    {
$    ttt='TRUE'
$    ELSE
$      {
$      ttt='FALSE'
$      }
$    }
$  write '[Name] :BOOLEAN = '+ttt
$  }

MAKRO WriteBoolean(Name)
{
  U:[name] = PAR.[name]
  if(PAR.[Name])
  {
    ttt__='TRUE'
    else
    {
      ttt__='FALSE'
    }
  }
  boolLine__ = "[Name] :BOOLEAN = " + ttt__ $ NO ITX
  @DeleteLineFromUnnamedSection(boolLine__)
  ok__ = Sect__::Select(SectionName__)
  if ok__
  {
    =Sect__::AddLine(boolLine__)
  }
}

$----------------------------------------------------------------------------


$MAKRO WriteReal ( Name )
$  {
$  write '[NAME] :REAL = '+TXT(PAR.[NAME])
$  }

MAKRO WriteReal ( Name )
{
  U:[name] = PAR.[name]
  realLine__ = "[NAME] :REAL = "+TXT(PAR.[NAME]) $ NO ITX
  @DeleteLineFromUnnamedSection(realLine__)
  ok__ = Sect__::Select(SectionName__)
  if ok__
  {
    =Sect__::AddLine(realLine__)
  }
}


$----------------------------------------------------------------------------


$MAKRO WriteInteger ( Name )
$  {
$  write '[NAME] :INTEGER = '+TXT(PAR.[NAME])
$  }

MAKRO WriteInteger ( Name )
{
  U:[name] = PAR.[name]
  intLine__ = "[NAME] :INTEGER = "+TXT(PAR.[NAME]) $ NO ITX
  @DeleteLineFromUnnamedSection(intLine__)
  ok__ = Sect__::Select(SectionName__)
  if ok__
  {
    =Sect__::AddLine(intLine__)
  }
}


$----------------------------------------------------------------------------


$MAKRO WriteText ( Name )
$  {
$  write '[NAME] :NAME = '''+PAR.[NAME] + ''''
$  }

MAKRO WriteText ( Name )
{
  U:[name] = PAR.[name]
  textLine__ = "[NAME] :NAME = '"+PAR.[NAME] + "'" $ NO ITX
  @DeleteLineFromUnnamedSection(textLine__)
  ok__ = Sect__::Select(SectionName__)
  if ok__
  {
    =Sect__::AddLine(textLine__)
  }
}


$MAKRO WriteKoord ( Name )
$  {
$  write '[NAME] :KOORD = '+TXT(PAR.[NAME])
$  }

MAKRO WriteKoord ( Name )
{
  U:[name] = PAR.[name]
  koordLine__ = "[NAME] :KOORD = "+TXT(PAR.[NAME]) $ NO ITX
  @DeleteLineFromUnnamedSection(textLine__)
  ok__ = Sect__::Select(SectionName__)
  if ok__
  {
    =Sect__::AddLine(textLine__)
  }
}
